function babelPluginTransformFsPromises(babel) {
    var t = babel.types;
    var moduleNames = new Set([
        "fs/promises",
        "node:fs/promises"
    ]);
    return {
        name: "transform-fs-promises",
        visitor: {
            CallExpression: function(path) {
                var node = path.node;
                if (t.isIdentifier(node.callee, {
                    name: "require"
                }) && 1 === node["arguments"].length && t.isStringLiteral(node["arguments"][0]) && moduleNames.has(node["arguments"][0].value)) path.replaceWith(t.memberExpression(t.callExpression(t.identifier("require"), [
                    t.stringLiteral("fs")
                ]), t.identifier("promises")));
                if (t.isImport(node.callee) && 1 === node["arguments"].length && t.isStringLiteral(node["arguments"][0]) && moduleNames.has(node["arguments"][0].value)) path.replaceWith(t.callExpression(t.memberExpression(t.callExpression(t.identifier("import"), [
                    t.stringLiteral("fs")
                ]), t.identifier("then")), [
                    t.arrowFunctionExpression([
                        t.identifier("m")
                    ], t.memberExpression(t.identifier("m"), t.identifier("promises")))
                ]));
            },
            ImportDeclaration: function(path) {
                var node = path.node;
                if (moduleNames.has(node.source.value) && 1 === node.specifiers.length && t.isImportDefaultSpecifier(node.specifiers[0])) {
                    var localName = node.specifiers[0].local.name;
                    path.replaceWith(t.importDeclaration([
                        t.importSpecifier(t.identifier(localName), t.identifier("promises"))
                    ], t.stringLiteral("fs")));
                }
                if (moduleNames.has(node.source.value) && node.specifiers.some(function(spec) {
                    return t.isImportSpecifier(spec);
                })) {
                    var namesSpecifiers = node.specifiers.filter(function(spec) {
                        return t.isImportSpecifier(spec);
                    });
                    var defaultSpec = node.specifiers.find(function(spec) {
                        return t.isImportDefaultSpecifier(spec);
                    });
                    var localPromises = t.identifier("_promises_no_conflict_alias");
                    path.replaceWithMultiple([
                        t.importDeclaration([
                            defaultSpec,
                            t.importSpecifier(localPromises, t.identifier("promises"))
                        ].filter(Boolean), t.stringLiteral("fs")),
                        t.variableDeclaration("const", [
                            t.variableDeclarator(t.objectPattern(namesSpecifiers.map(function(spec) {
                                return t.objectProperty(spec.local, spec.imported, false, true);
                            })), localPromises)
                        ])
                    ]);
                }
            }
        }
    };
}
var src_rslib_entry_ = babelPluginTransformFsPromises;
export { babelPluginTransformFsPromises, src_rslib_entry_ as default };

//# sourceMappingURL=index.mjs.map